/// @cond EO_CXX_EO_IMPL

inline void elm::dayselector::weekdays_names_set(const char ** weekdays_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_dayselector_weekdays_names_set(weekdays_));
}

inline ::efl::eina::list< Eina_Stringshare * > elm::dayselector::weekdays_names_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_dayselector_weekdays_names_get());
   return ::efl::eolian::to_cxx<::efl::eina::list< Eina_Stringshare * >>(_tmp_ret, std::tuple<std::true_type, std::true_type>());
}

inline void elm::dayselector::day_selected_set(Elm_Dayselector_Day day_, bool selected_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_dayselector_day_selected_set(day_, ::efl::eolian::to_c(selected_)));
}

inline bool elm::dayselector::day_selected_get(Elm_Dayselector_Day day_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_dayselector_day_selected_get(day_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Elm_Dayselector_Day elm::dayselector::week_start_get() const
{
   Elm_Dayselector_Day _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_dayselector_week_start_get());
   return _tmp_ret;
}

inline void elm::dayselector::week_start_set(Elm_Dayselector_Day day_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_dayselector_week_start_set(day_));
}

inline unsigned int elm::dayselector::weekend_length_get() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_dayselector_weekend_length_get());
   return _tmp_ret;
}

inline void elm::dayselector::weekend_length_set(unsigned int length_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_dayselector_weekend_length_set(length_));
}

inline Elm_Dayselector_Day elm::dayselector::weekend_start_get() const
{
   Elm_Dayselector_Day _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_dayselector_weekend_start_get());
   return _tmp_ret;
}

inline void elm::dayselector::weekend_start_set(Elm_Dayselector_Day day_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_dayselector_weekend_start_set(day_));
}

inline void eo_cxx::elm::dayselector::weekdays_names_set(const char ** weekdays_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_dayselector_weekdays_names_set(weekdays_));
}

inline ::efl::eina::list< Eina_Stringshare * > eo_cxx::elm::dayselector::weekdays_names_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_dayselector_weekdays_names_get());
   return ::efl::eolian::to_cxx<::efl::eina::list< Eina_Stringshare * >>(_tmp_ret, std::tuple<std::true_type, std::true_type>());
}

inline void eo_cxx::elm::dayselector::day_selected_set(Elm_Dayselector_Day day_, bool selected_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_dayselector_day_selected_set(day_, ::efl::eolian::to_c(selected_)));
}

inline bool eo_cxx::elm::dayselector::day_selected_get(Elm_Dayselector_Day day_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_dayselector_day_selected_get(day_));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}

inline Elm_Dayselector_Day eo_cxx::elm::dayselector::week_start_get() const
{
   Elm_Dayselector_Day _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_dayselector_week_start_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::dayselector::week_start_set(Elm_Dayselector_Day day_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_dayselector_week_start_set(day_));
}

inline unsigned int eo_cxx::elm::dayselector::weekend_length_get() const
{
   unsigned int _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_dayselector_weekend_length_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::dayselector::weekend_length_set(unsigned int length_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_dayselector_weekend_length_set(length_));
}

inline Elm_Dayselector_Day eo_cxx::elm::dayselector::weekend_start_get() const
{
   Elm_Dayselector_Day _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::elm_obj_dayselector_weekend_start_get());
   return _tmp_ret;
}

inline void eo_cxx::elm::dayselector::weekend_start_set(Elm_Dayselector_Day day_) const
{
   eo_do(_concrete_eo_ptr(), ::elm_obj_dayselector_weekend_start_set(day_));
}

inline ::eo_cxx::elm::dayselector::operator ::elm::dayselector() const
{
   return *static_cast<::elm::dayselector const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::elm::dayselector::operator ::elm::dayselector&()
{
   return *static_cast<::elm::dayselector*>(static_cast<void*>(this));
}

inline ::eo_cxx::elm::dayselector::operator ::elm::dayselector const&() const
{
   return *static_cast<::elm::dayselector const*>(static_cast<void const*>(this));
}

template <typename T>
void elm_dayselector_weekdays_names_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, const char ** weekdays_)
{
   try
      {
         static_cast<T*>(self->this_)->weekdays_names_set(weekdays_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
::efl::eina::list< Eina_Stringshare * > elm_dayselector_weekdays_names_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->weekdays_names_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_List * _tmp_ret{};
         return ::efl::eolian::to_cxx<::efl::eina::list< Eina_Stringshare * >>(_tmp_ret, std::tuple<std::true_type, std::true_type>());
      }
}

template <typename T>
void elm_dayselector_day_selected_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Dayselector_Day day_, Eina_Bool selected_)
{
   try
      {
         static_cast<T*>(self->this_)->day_selected_set(day_, ::efl::eolian::to_cxx<bool>(selected_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
bool elm_dayselector_day_selected_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Dayselector_Day day_)
{
   try
      {
         return static_cast<T*>(self->this_)->day_selected_get(day_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Eina_Bool _tmp_ret{};
         return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }
}

template <typename T>
Elm_Dayselector_Day elm_dayselector_week_start_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->week_start_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Dayselector_Day _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_dayselector_week_start_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Dayselector_Day day_)
{
   try
      {
         static_cast<T*>(self->this_)->week_start_set(day_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
unsigned int elm_dayselector_weekend_length_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->weekend_length_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         unsigned int _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_dayselector_weekend_length_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, unsigned int length_)
{
   try
      {
         static_cast<T*>(self->this_)->weekend_length_set(length_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

template <typename T>
Elm_Dayselector_Day elm_dayselector_weekend_start_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   try
      {
         return static_cast<T*>(self->this_)->weekend_start_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
         Elm_Dayselector_Day _tmp_ret{};
         return _tmp_ret;
      }
}

template <typename T>
void elm_dayselector_weekend_start_set_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Elm_Dayselector_Day day_)
{
   try
      {
         static_cast<T*>(self->this_)->weekend_start_set(day_);
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::elm::dayselector >
{
   template <typename T>
   struct type
         : virtual operations< ::elm::layout >::template type<T>
   {
      virtual void weekdays_names_set(const char ** weekdays_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_dayselector_weekdays_names_set(weekdays_));
      }

      virtual ::efl::eina::list< Eina_Stringshare * > weekdays_names_get()
      {
         Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_dayselector_weekdays_names_get());
            return ::efl::eolian::to_cxx<::efl::eina::list< Eina_Stringshare * >>(_tmp_ret, std::tuple<std::true_type, std::true_type>());
      }

      virtual void day_selected_set(Elm_Dayselector_Day day_, bool selected_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_dayselector_day_selected_set(day_, ::efl::eolian::to_c(selected_)));
      }

      virtual bool day_selected_get(Elm_Dayselector_Day day_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_dayselector_day_selected_get(day_));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual Elm_Dayselector_Day week_start_get()
      {
         Elm_Dayselector_Day _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_dayselector_week_start_get());
            return _tmp_ret;
      }

      virtual void week_start_set(Elm_Dayselector_Day day_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_dayselector_week_start_set(day_));
      }

      virtual unsigned int weekend_length_get()
      {
         unsigned int _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_dayselector_weekend_length_get());
            return _tmp_ret;
      }

      virtual void weekend_length_set(unsigned int length_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_dayselector_weekend_length_set(length_));
      }

      virtual Elm_Dayselector_Day weekend_start_get()
      {
         Elm_Dayselector_Day _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::elm_obj_dayselector_weekend_start_get());
            return _tmp_ret;
      }

      virtual void weekend_start_set(Elm_Dayselector_Day day_)
      {

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               ::elm_obj_dayselector_weekend_start_set(day_));
      }

   };
};


template<>
struct operation_description_class_size< ::elm::dayselector >
{
   static constexpr int value = 
#if defined(DAYSELECTOR_PROTECTED) && defined(DAYSELECTOR_BETA)
      10
#elif defined(DAYSELECTOR_PROTECTED)
      10
#elif defined(DAYSELECTOR_BETA)
      10
#else
      10
#endif
      + operation_description_class_size<::elm::layout >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::elm::dayselector>
                                 , Eo_Op_Description* ops)
{
   int i = 0;
   (void)i;
   (void)ops;
   ops[i].func = reinterpret_cast<void*>(& ::elm_dayselector_weekdays_names_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_dayselector_weekdays_names_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_dayselector_weekdays_names_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_dayselector_weekdays_names_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_dayselector_day_selected_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_dayselector_day_selected_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_dayselector_day_selected_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_dayselector_day_selected_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_dayselector_week_start_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_dayselector_week_start_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_dayselector_week_start_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_dayselector_week_start_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_dayselector_weekend_length_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_dayselector_weekend_length_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_dayselector_weekend_length_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_dayselector_weekend_length_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_dayselector_weekend_start_get_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_dayselector_weekend_start_get);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   ops[i].func = reinterpret_cast<void*>(& ::elm_dayselector_weekend_start_set_wrapper<T>);
   ops[i].api_func = reinterpret_cast<void*>(& ::elm_obj_dayselector_weekend_start_set);
   ops[i].op_type = EO_OP_TYPE_REGULAR;
   ++i;

   initialize_operation_description<T>(::efl::eo::detail::tag<::elm::layout>(), &ops[operation_description_class_size< ::elm::dayselector >::value]);
   return 0;
}
inline Eo_Class const* get_eo_class(tag<::elm::dayselector>)
{
   return (ELM_DAYSELECTOR_CLASS);
}

} } }

/// @endcond

